
import { Row, Col, Card, Tree, Form, TreeSelect, Input, InputNumber, Modal, Button, message } from 'antd'
import moment from 'moment';
// import React, { useEffect, useState, useCallback,useRef } from 'react';
import TreedataFrom from './form';

const { TreeNode, DirectoryTree } = Tree;
const FormItem = Form.Item;

//-----------------------------------
const onAdd = (key) => {
  if (expandedKeys.indexOf(key) === -1) {
    expandedKeyArr.push(key);
  }
  expandedKeys(expandedKeyArr.slice());
  addNode(key, treeData);//添加节点 树形
  setData(treeData.slice());//添加子项
};
//-----------------------------------
const confirm = data => {
  // {...data,isPublish}
  if (data.key !== 0) {
    Modal.confirm({
      title: '确认删除吗？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        message.error('失败');

      },
    });
  } else {
    message.error('error')
  }
}


// function uuid() {
//   var s = [];
//   var hexDigits = "0123456789";
//   for (var i = 0; i < 18; i++) {
//       s[i] = hexDigits.substr(Math.floor(Math.random() * 1*10), 1);
//   }

//   var uuid = s.join("");
//   return uuid;
// }
// import moment from 'moment';


const treeData =
  [
    {
      title: '分厂厂长管理',
      key: '0',
      selectable: false,
      children: [
        { title: '郎岩', phone: '15920583224', remark: "", day: "1992-11-13", cardId: '511502199103223189', sex: 1, id: '0212', belon: 1, homeaddres: 1, key: '0-0-0-1' },//这个不行么 你写错了 你那是v4的写法在哪？刚刚那个啊。对
        { title: '柯琼彦', phone: '13184013427', remark: "", day: "1991-11-22", cardId: '210203197503102721', sex: 2, id: '4242', belon: 2, homeaddres: 2, key: '0-0-0-2', },
      ],
    },
    {
      title: '分厂员工管理',
      key: '0-0-1',
      selectable: false,
      children: [
        { title: '伏佳', phone: '18613523527', remark: "", day: "1992-10-11", cardId: '520323197806058856', sex: 1, id: '1124', belon: 4, homeaddres: 4, key: '0-0-1-0' },
        { title: '舒宏', phone: '14736632088', remark: "", day: "1992-12-13", cardId: '610729197408202551', sex: 1, id: '4534', belon: 3, homeaddres: 2, key: '0-0-1-1' },
        { title: '狄莉珍', phone: '17604898508', remark: "", day: "1993-10-11", cardId: '820000195008115837', sex: 1, id: '4242', belon: 1, homeaddres: 5, key: '0-0-1-2' },
      ],
    },
  ]




// const item = this.info.node.key 不是！！！！

class TreeDemo extends React.Component {
  formRef = React.createRef();


  constructor(props) {
    super(props)
    this.state = {
      expandedKeys: ['0-0-0', '0-0-1'],
      autoExpandParent: false,
      checkedKeys: ['0-0-0'],
      selectedKeys: [],
      // treeTitle: [info.node.props],
      checked: true,
      treeData: treeData
    };
  }


  onExpand = expandedKeys => {
    console.log('onExpand', expandedKeys);

    // 如果没有将 autoExpandParent 设置为 false，如果子项展开，父项不能折叠。
    // 或者，您可以删除所有扩展的子键。
    this.setState({
      expandedKeys,
      autoExpandParent: false,
    });
  };

  handelSex = e => {
    this.setState({
      sex: e.target.value
    });
    console.log(valeu);
  };


  onChangethis = (value) => {

    const treeData = this.state.treeData

    let Data1 = this.state.treeData
    for (var i = 0; i < treeData.length; i++) {

      for (var j = 0; j < treeData[i].children.length; j++) {
        // console.log(Data1[i].children[j].key);
        // console.log("---------")
        // console.log(value);
        if (treeData[i].children[j].key == value.key) {

          Data1[i].children[j] = value
          //qileguaile wo cao
          console.log(Data1[i].children[j]);
          // console.log(treeData[i].children[j].key)
          break
        }
      }

    }
  }
  //删除
  onDelect = (value) => {
    const treeData = this.state.treeData
    let Data1 = this.state.treeData
    for (var i = 0; i < treeData.length; i++) {
      for (var j = 0; j < treeData[i].children.length; j++) {

        if (treeData[i].children[j].key == value.key) {

          delete Data1[i].children[j]
          break
        }
      }

    }
    // console.log("----Data1-----")
    // console.log(Data1)
    this.setState({
      treeData: Data1
    }, () => {
      message.success('shanchuchenggong')
    })

  }



  onSelect = (values, info) => {
    // this.FromValue(info.node)
    console.log(this.state.treeData)
    console.log(info)
    this.setState({ values }, () => {
      this.formRef.current.setFieldsValue({
        ...info.node.props,
        key: info.node.props.eventKey,//event
        day: moment(info.node.props.day)
      })

      console.log(values, info)

      // moment(info.node.props.day).format('YYYY-MM-DD')
    })
  }




  renderTreeNodes = data =>
    data.map(item => {
      if (item.children) {
        return (
          <TreeNode title={item.title} key={item.key} dataRef={item}  >
            {this.renderTreeNodes(item.children)}
          </TreeNode >
        );
      }
      return <TreeNode key={item.key} {...item} />;
    });



  render() {

    return (
      <Card>
        <Row >
          <Col xs={{ span: 5, offset: 1 }} lg={{ span: 6, offset: 0 }}>
            <Card>
              <FormItem
                label="管辖部门"
              >
                <Button type="primary" onClick={onAdd} >
                  增加
                </Button>

                <Tree

                  showLine
                  // switcherIcon={<DownOutlined />}
                  defaultExpandedKeys={['0-0-0']}
                  onSelect={this.onSelect}
                  treeData={this.state.treeData}
                >
                  {this.renderTreeNodes(this.state.treeData)}
                  {/* 动态渲染 */}
                </Tree >
                {/* 不加入生命周期不会有更改a */}
              </FormItem>
            </Card>
          </Col>
          <Col xs={{ span: 10, offset: 10 }} lg={{ span: 10, offset: 4 }}>
            <Card>
              <TreedataFrom
                ref={this.formRef}
                triggerRef={this.bindRef}
                onChangethis={this.onChangethis}
                onSubmit={this.onChangethis}
              />
            </Card>
          </Col>
        </Row>
      </Card>
    );
  }

}

export default TreeDemo